using System;
using System.Data;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class asyncgridview : System.Web.UI.Page, ICallbackEventHandler
{
  protected void Page_Load(object sender, EventArgs e)
  {
    if (!Page.IsCallback)
      ltCallback.Text = ClientScript.GetCallbackEventReference(this, "'bindgrid'", "EndGetData", "'asyncgrid'", false);
  }

  private DataTable RetrieveDataTableFromDatabase()
  {
    DataTable table = new DataTable();
    table.Columns.Add("Product", typeof(string));
    table.Columns.Add("Price", typeof(float));

    table.Rows.Add("Hat", 16);
    table.Rows.Add("Jacket", 234);
    table.Rows.Add("Socks", 35);

    return table;
  }

  #region ICallbackEventHandler Members

  private string _Callback;

  public string GetCallbackResult()
  {
    return _Callback;
  }

  public void RaiseCallbackEvent(string eventArgument)
  {
    DataTable table = RetrieveDataTableFromDatabase();
    gvAsync.DataSource = table;
    gvAsync.DataBind();

    using (System.IO.StringWriter sw = new System.IO.StringWriter())
    {
      gvAsync.RenderControl(new HtmlTextWriter(sw));
      _Callback = sw.ToString();
    }
  }

  #endregion
}
